#include "Color.hpp"
#include "Exceptions.hpp"

enum class ColorValue {__NOT_A_COLOR, __BLACK, __WHITE};

const Color NOT_A_COLOR = Color(ColorValue::__NOT_A_COLOR);
const Color BLACK = Color(ColorValue::__BLACK);
const Color WHITE = Color(ColorValue::__WHITE);

Color::Color()
    : value(ColorValue::__NOT_A_COLOR)
{
    // none
};

Color::Color(ColorValue cv)
    : value(cv)
{
    // none
};

Color Color::from_fen(std::string str) {
    if (str == "w" || str == "W") return WHITE;
    if (str == "b" || str == "B") return BLACK;

    throw CustomException("Bad fen color in from_fen()");
}

std::string Color::to_fen() const {
    if ((*this) == WHITE) return "w";
    if ((*this) == BLACK) return "b";

    throw CustomException("Bad color in to_fen()");
}

Color Color::inverse() const {
    if ((*this) == WHITE) return BLACK;
    if ((*this) == BLACK) return WHITE;

    throw CustomException("Bad color in Color::inverse()");
}

bool Color::operator==(const Color& rhs) const
{
    return (*this).value == rhs.value;
};

bool Color::operator!=(const Color& rhs) const
{
    return (*this).value != rhs.value;
};
