#ifndef SEARCH
#define SEARCH

#include <utility>

#include "Board.hpp"
#include "Move.hpp"
#include "Evaluation.hpp"

namespace Search {
	Move best_move(Board&, UNumber, bool managed = false);

    std::pair<Score, std::list<Move>> negamax(Board&, UNumber);
    std::pair<Score, std::list<Move>> alphabeta(Board&, Score, Score, UNumber);
    std::pair<Score, std::list<Move>> negascout(Board&, Score, Score, UNumber);

	class Manager {
	public:
		static void reset();

		static UNumber depth;
        static UNumber movetime;
        static UNumber nodes;
		static Board board;

		static void start();
		static void stop();
		static void clear();
		static void join_all();

		static bool stoped;
		static Move best_move;
		static UNumber current_depth;
	private:

		static void inc_search();
	};
}

#endif
